/* attention: there is something wrong; explain: what design mistakes were made? what would you do instead? */

#include "buggy-is-prime.h"

/*
 * this function takes an long argument k.
 * it returns a pointer to an long value that is the first number >= k that is a prime number.
 */
long* allocate_next_prime_number(long k)
{
   /*
    * loop goes on until a prime number is found
    * 
    * note that k is passed by value, so we can increment it without affecting the calling function
    */
   while(true)
   {
      long* n = new long(k);
      if(is_prime(n)) return n;
      k++;
   }
}

/*
 * receives an long pointer (long* n)
 * checks whether *n, the long value stored at that address, is a prime number
 */
bool is_prime(long* n)
{
   /*
    * explicitly handle multiples of two and three
    */
   if((*n%2 == 0) || (*n%3 == 0))
   {
      /*
       * deallocate the pointer since the value is no longer needed
       */
      delete n;
      return false;
   }
   
   /*
    * now we only need to check divisibility by 6k-1 and 6k+1, gaining us a factor 3 speedup
    */
   for(long i = 5; *n >= i*i; i += 6)
   {
      if((*n % i == 0) || (*n % (i+2) == 0))
      {
         /*
          * deallocate the pointer since the value is no longer needed
          */
         delete n;
         return false;
      }
   }

   // hooray, it's a prime number
   // pointer may still be needed, so we don't delete it and simply return "true"
   //
   return true;
}

