/* attention: there is something wrong; explain: what design mistakes were made? what would you do instead? */

#include <iostream>
#include <chrono>

#include "buggy-is-prime.h"

// here we simply repeat the time measurement from the tutorial

namespace
{
   constexpr int num_tests = 10000;
   
   constexpr int xstep = 1;
   constexpr int xmin = 1;
   constexpr int xmax = 1000000;
}

double time_measurement(long n)
{
   auto t0 = std::chrono::high_resolution_clock::now();
   for(int i = 0; i < num_tests; i++)
   {
      is_prime(new long{n});  /* this version of is_prime takes a pointer, so let's pass a pointer */
   }
   auto t1 = std::chrono::high_resolution_clock::now();
   return std::chrono::duration_cast<std::chrono::nanoseconds>(t1-t0).count() / (double)num_tests;
}

int main()
{
   for(long x = xmin; xmax >= x; x += xstep)
   {
      std::cout << x << "\t\t" << time_measurement(x) << "\n";
      std::cout.flush();
   }
}
